SealBar = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0")
SealBar:RegisterChatCommand("/SealBar", nil)
local Spammed = false

-- COUNT TOTAL ENTRIES IN A TABLE
local function countEntries(tbl)
    local cnt = 0;
    for k in pairs(tbl) do cnt = cnt + 1; end
    return cnt
end

-- RETURN CLASS
local function ClassCheck()
    local _, class = UnitClass("player")
    if class == "PALADIN" then return true else return false end
end

-- FIND HIGHEST SPELL RANK
local function GetSpellID(spell, rank)
	local i = 1
	local spellID
	local highestRank
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			break
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i
				end
			else
				spellID = i
				highestRank = spellRank
			end
		end
		i = i + 1
		if (i > 250) then
			break
		end
	end			
	return spellID, highestRank
end

function SealBar:OnEnable()
    if ClassCheck() then
        self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
        self:RegisterEvent("CHARACTER_POINTS_CHANGED")

        SealBarLoad()
    end
end

function SealBar:CHARACTER_POINTS_CHANGED()
    if not Spammed then
        Spammed = true
        DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 "..SealBarNotice[1])
        DEFAULT_CHAT_FRAME:AddMessage(" "..SealBarNotice[2])
    end
end

function SealBarUpdate()
    -- thanks to ckknight & navcaririel for the line below!
    local num = tonumber((this:GetName()):match("%d+"))
    local spellName = SealBarSpells[num]
    if not GetSpellID(spellName) then return end
    local usable, nomana = IsUsableSpell(spellName)

    -- CLEAR
    if getglobal("SealBarButton"..num).texture then getglobal("SealBarButton"..num).texture:SetVertexColor(1, 1, 1) end
    
    -- CHANGE TO RED IF OUT OF RANGE
    if IsSpellInRange(spellName, "target") == 0 then
        if getglobal("SealBarButton"..num).texture then getglobal("SealBarButton"..num).texture:SetVertexColor(0.8, 0.1, 0.1) end
    end

    -- CHANGE TO BLUE IF INSUFFICIENT MANA
    if nomana then
        if getglobal("SealBarButton"..num).texture then getglobal("SealBarButton"..num).texture:SetVertexColor(.1, .3, 1) end
    end
    
    -- GREY OUT IF FLYING/DEAD/GHOST
    if UnitIsDeadOrGhost("player") or UnitOnTaxi("player") then
        if getglobal("SealBarButton"..num).texture then getglobal("SealBarButton"..num).texture:SetVertexColor(.3, .3, .3) end
    end
end

function SealBarLoad()
    if getglobal(SealBarButton1) then return end
    local width, height, scale = 60, 60, .636
    local SealBarLastButton = "MultiBarBottomRightButton12"
    
    SealBarButton1 = CreateFrame("Button", "SealBarButton1", UIParent, "SealBarButtonTemplate")
    SealBarButton2 = CreateFrame("Button", "SealBarButton2", UIParent, "SealBarButtonTemplate")
    SealBarButton3 = CreateFrame("Button", "SealBarButton3", UIParent, "SealBarButtonTemplate")
    SealBarButton4 = CreateFrame("Button", "SealBarButton4", UIParent, "SealBarButtonTemplate")
    SealBarButton5 = CreateFrame("Button", "SealBarButton5", UIParent, "SealBarButtonTemplate")
    SealBarButton6 = CreateFrame("Button", "SealBarButton6", UIParent, "SealBarButtonTemplate")
    SealBarButton7 = CreateFrame("Button", "SealBarButton7", UIParent, "SealBarButtonTemplate")
    SealBarButton8 = CreateFrame("Button", "SealBarButton8", UIParent, "SealBarButtonTemplate")

    for i = 1, countEntries(SealBarSpells) do
        local button = getglobal("SealBarButton"..i)
        
        if GetSpellID(SealBarSpells[i]) then
            button:SetWidth(width); button:SetHeight(height); button:SetScale(scale); button:EnableMouse(true)
            
            if (i == 1) then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            elseif (SealBarLastButton == "MultiBarBottomRightButton12") then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            else
                button:SetPoint("CENTER", SealBarLastButton, "LEFT", -36, 0)
            end
            
            button:SetAttribute("type", "spell")
            button:SetAttribute("spell", SealBarSpells[i])

            button:SetScript("OnLeave", function() GameTooltip:Hide() end)
            button:SetScript("OnEnter", function()
                GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
                GameTooltip:SetSpell(GetSpellID(SealBarSpells[i]))
                GameTooltip:Show()
            end)

            local t = button:CreateTexture(nil,"BACKGROUND")
                t:SetTexture(GetSpellTexture(SealBarSpells[i]))
                t:SetAllPoints(button)
                button.texture = t
            
            SealBarLastButton = button
        else
            button:Hide()
        end
    end
end

-- UPDATE COOLDOWN
function SealBar:SPELL_UPDATE_COOLDOWN()
    if ClassCheck() then
        for i = 1, countEntries(SealBarSpells) do
            if (GetSpellCooldown(SealBarSpells[i]) ~= nil and GetSpellCooldown(SealBarSpells[i]) > 0) then
                local start, duration, enable = GetSpellCooldown(SealBarSpells[i])
                getglobal("SealBarButton".. i .."Cooldown"):SetCooldown(start, duration)
            end
        end
    end
end